#include "tree.h"
#include "btree.h"
#include <fstream>
using namespace std;
using namespace aed;

template <class T>
void plotTree(tree<T> &Tr, typename tree<T>::iterator nodeIt, ofstream &out);

template <class T>
void plotTree(tree<T> &Tr,string fileName="graphViz.gv"){
	
	ofstream out(fileName.c_str());
	out<<"digraph G{"<<endl;
	plotTree(Tr,Tr.begin(),out);
	out<<"}"<<endl;
	
	string command="dot ";
	command+=fileName;
	command+=" -Tpng -O";
	//invoke console
	system(command.c_str());
}

template <class T>
void plotTree(btree<T> &Tr,string fileName="graphViz.gv"){
	
	ofstream out(fileName);
	out<<"digraph G{"<<endl;
	plotTree(Tr,Tr.begin(),out);
	out<<"}"<<endl;
	string command="dot ";
	command+=fileName;
	command+=" -Tpng -O";
	//invoke console
	system(command.c_str());
}

template <class T>
void plotTree(tree<T> &Tr, typename tree<T>::iterator nodeIt, ofstream &out){
	if(nodeIt==Tr.end())
	return;
	out<<"\""<< &(*nodeIt)<<"\""<< "[label=" <<*nodeIt<< "]"<<endl;

	typename tree<T>::iterator childIt;

	childIt=nodeIt.lchild();
	while(childIt!=Tr.end()){
		plotTree(Tr,childIt,out);
		out<< "\""<<&(*nodeIt)<<"\"" <<" -> " << "\""<<&(*childIt)<<"\""<<endl;
		childIt++;
	}
}

	template <class T>
	void plotTree(btree<T> &Tr, typename btree<T>::iterator nodeIt, ofstream &out){
	if(nodeIt==Tr.end())
	return;

	out<<"\""<< &(*nodeIt)<<"\""<< "[label=" <<*nodeIt<< "]"<<endl;

	if(nodeIt.left()!=Tr.end()){
		plotTree(Tr,nodeIt.left(),out);
		out<< "\""<<&(*nodeIt)<<"\"" <<" -> " << "\""<<&(*nodeIt.left())<<"\""<<endl;
	}
		
	if(nodeIt.right()!=Tr.end()){
	plotTree(Tr,nodeIt.right(),out);
	out<< "\""<<&(*nodeIt)<<"\"" <<" -> " << "\""<<&(*(nodeIt.right()))<<"\""<<endl;
	}
	
}
